/*
 * =====================================================================================
 *
 *       Filename:  test_pgm.cpp
 *
 *    Description:  test pgm file reading
 *
 *        Version:  1.0
 *        Created:  03/27/2012 03:44:34 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ming Liu (), ming.liu@mavt.ethz.ch
 *        Company:  ETHZ
 *
 * =====================================================================================
 */

#include <iostream>

#include "occupancygrid.h"
//#include "GVGcu.h"
//#include "cpugvg.h"
//#include "voronoi.h"
#include "assert.h"
#include "vtktool.h"

#include <time.h>

using namespace std;
using namespace topomap;
/* 
 * ===  FUNCTION  ============================================================
 *         Name:  Main  
 *  Description:  Entry of program
 * ===========================================================================
 */
int main ( int argc, char *argv[] )
{
    cout << "Input file name: "<< argv[1];
    string filename(argv[1]);
    
    /*-----------------------------------------------------------------------------
     *  VTK 3d version
     *-----------------------------------------------------------------------------*/
    cout << "3D vtk version..." << endl;
    float length = 1.0;
    float samplerate = 1.0;
    if(argc > 2)
      length = atof(argv[2]);
    if (argc > 3)
      samplerate = atof(argv[3]);
    cout << "Sample ratio from original cloud: " << samplerate << endl;
    cout << "Grid length: " << length << endl;
    Grid grid3d(filename, length, length, length, samplerate);// in 3d case the final scale-of-image value doesn't count
    VTKTool::dumpGridCell("freea.vtk", grid3d.freeCells);
    exit(0);

    return 1;
}	/* ----------  end of function main  ---------- */
